/*
   Sistemas Integrados TEKNISA
   Nome: 0003_FASSTPO_FATURA_SERV_SUPORTE.SQL
   Descrio: Procedimento para Faturamento de Atendimentos do Suporte.
   Criao: 06/11/2007 Vanrochris Helbert Vieira
*/

CREATE OR REPLACE PROCEDURE FATURA_SERV_SUPORTE
(
   P_CDCLIENTE  IN CLIENTE.CDCLIENTE%TYPE,
   P_CDOPERAPUR IN APURFATUFAS.CDOPERAPUR%TYPE,
   P_CDFILIAL   IN FILIAL.CDFILIAL%TYPE
)
AS
   V_CDEMPRESA    VARCHAR2(2);
   V_CDPRODUTO    VARCHAR2(10);
   V_NMTIPOSERV   VARCHAR2(80);
   V_CDTIPOSERV   VARCHAR2(3);
   V_PRXAPURACAO  VARCHAR2(20);
   V_VRFATU       NUMBER;
   V_QTHRAPR      NUMBER;
   V_QTHRTOT      NUMBER;
   V_VALORSERV    NUMBER;
   V_DATA         DATE;
   V_DATAINI      DATE;
   V_DATAFIN      DATE;
   V_DSBOLETCLIE  PARCLIEFAS.DSBOLETCLIE%TYPE;
BEGIN

   SELECT
       TRUNC(TO_DATE(SYSDATE))
   INTO
      V_DATA
   FROM
      DUAL;

   BEGIN
      SELECT
         MIN(TRUNC(T.DTCONCTAREFA))
      INTO
         V_DATAINI
      FROM
         TAREFA T,
         PLANATIVTARE P,
         APROATIVTARE A,
         ASSUNTO S
      WHERE
         T.IDORIGTARE   = '2'              AND
         T.IDSITTAREFA  = 'C'              AND
         T.IDTARATEFAT  = 'S'              AND
         S.IDATEFATUR   = 'S'              AND
         T.CDASSUNTO    = S.CDASSUNTO      AND
         A.CDFILIAL     = P.CDFILIAL       AND
         A.NRTAREFA     = P.NRTAREFA       AND
         A.NRPLATIVTARE = P.NRPLATIVTARE   AND
         T.CDFILIAL     = P.CDFILIAL       AND
         T.NRTAREFA     = P.NRTAREFA       AND
         (T.CDCLIENTE   = P_CDCLIENTE      OR
         P_CDCLIENTE  = 'C')               AND
         P.NRAPURFATFAS IS NULL;            
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         NULL;
   END;
   
   IF V_DATAINI IS NULL THEN
      V_DATAINI := V_DATA;
   ELSE
      V_DATAINI := TO_DATE(('01/' || TO_CHAR(V_DATAINI, 'MM/YYYY')));
      V_DATAFIN := ADD_MONTHS(V_DATAINI, 1);
      V_DATAFIN := V_DATAFIN - 1;
   END IF;

   WHILE V_DATAINI < TO_DATE(('01/' || TO_CHAR(V_DATA, 'MM/YYYY'))) LOOP

      FOR CUR_CLIE IN (SELECT DISTINCT
                          T.CDCLIENTE
                       FROM
                          TAREFA T,
                          PLANATIVTARE P,
                          APROATIVTARE A,
                          ASSUNTO S
                       WHERE
                          T.IDORIGTARE   = '2'              AND
                          T.IDSITTAREFA  = 'C'              AND
                          T.IDTARATEFAT  = 'S'              AND
                          S.IDATEFATUR   = 'S'              AND
                          T.CDASSUNTO    = S.CDASSUNTO      AND
                          A.CDFILIAL     = P.CDFILIAL       AND
                          A.NRTAREFA     = P.NRTAREFA       AND
                          A.NRPLATIVTARE = P.NRPLATIVTARE   AND
                          T.CDFILIAL     = P.CDFILIAL       AND
                          T.NRTAREFA     = P.NRTAREFA       AND
                          (T.CDCLIENTE   = P_CDCLIENTE      OR
                          P_CDCLIENTE  = 'C')               AND
                          P.NRAPURFATFAS IS NULL            AND 
                          (TRUNC(T.DTCONCTAREFA) BETWEEN V_DATAINI AND V_DATAFIN) 
                       ORDER BY
                          T.CDCLIENTE) LOOP
                       
         BEGIN
            SELECT
               MAX(T.CDPRODFATU),
               MAX(P.CDTIPOSERV),
               MAX(T.NMTIPOSERV),
               MAX(V.VRHORACLIE),
               MAX(P.CDEMPRESA)
            INTO
               V_CDPRODUTO,
               V_CDTIPOSERV,
               V_NMTIPOSERV,
               V_VALORSERV,
               V_CDEMPRESA
            FROM
               TIPOSERV T,
               CONTRATOSERV C,
               VALORSERV V,
               PARCLIEFAS P
            WHERE
               T.CDTIPOSERV   = P.CDTIPOSERV       AND
               P.CDCLIENTE    = CUR_CLIE.CDCLIENTE AND
               P.CDCLIENTE    = C.CDCLIENTE        AND
               C.NRPROPOSFAS  = V.NRPROPOSFAS      AND
               C.NRVERPROPFAS = V.NRVERPROPFAS     AND  
               C.CDTIPOSERV   = V.CDTIPOSERV       AND            
               C.CDTIPOSERV   = T.CDTIPOSERV       AND
               C.NRSERVCONT   = V.NRSERVCONT       AND    
               P.IDTPFATUCLIE = '6';
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               NULL;
         END;

         V_VRFATU := 0;
         V_QTHRTOT := 0;
   
         NOVO_CODIGO('APURFATUFAS', V_PRXAPURACAO);
 
         BEGIN
            SELECT
               DSBOLETCLIE
            INTO
               V_DSBOLETCLIE
            FROM
               PARCLIEFAS
            WHERE
               CDCLIENTE = CUR_CLIE.CDCLIENTE AND
               IDTPFATUCLIE = '1';
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               NULL;
         END;
      
         INSERT INTO APURFATUFAS(CDFILIAL, CDCLIENTE,
                                 NRAPURFATFAS, DTAPURFATFAS,
                                 VRTOTAFATFAS, DSEMISSPRONF,
                                 CDOPERAPUR, CDEMPRESA,
                                 CDTIPOSERV, CDPRODUTO,
                                 NRLANCTONF, IDAPURFATFAS, IDSTAPFATFAS, IDCOMIFATFAS,
                                 DSBOLEFATFAS, DTMESAPURFAS)
         VALUES(P_CDFILIAL, CUR_CLIE.CDCLIENTE,
                SUBSTR(V_PRXAPURACAO, 11, 10), V_DATA,
                V_VRFATU, ('SD - ' || V_NMTIPOSERV),
                P_CDOPERAPUR, V_CDEMPRESA,
                V_CDTIPOSERV, V_CDPRODUTO,
                NULL, '2', 'P', 'N',
                V_DSBOLETCLIE, V_DATAINI);

         FOR CUR_DESK IN (SELECT
                             T.CDFILIAL,
                             T.NRTAREFA,
                             SUM(B.VRTEMPOAPROP) AS VRTEMPOAPROP
                          FROM
                             TAREFA T,
                             PLANATIVTARE P,
                             ASSUNTO S,
                             (SELECT
                                 CDFILIAL,
                                 NRTAREFA,
                                 NRPLATIVTARE,
                                 SUM(NVL((DTFAPATIVTAR - DTIAPATIVTAR) * 24, 0)) AS VRTEMPOAPROP
                              FROM
                                 APROATIVTARE
                              GROUP BY
                                 CDFILIAL,
                                 NRTAREFA,
                                 NRPLATIVTARE) B
                          WHERE
                             T.IDORIGTARE   = '2'                 AND
                             T.IDSITTAREFA  = 'C'                 AND
                             T.IDTARATEFAT  = 'S'                 AND
                             S.IDATEFATUR   = 'S'                 AND
                             T.CDASSUNTO    = S.CDASSUNTO         AND
                             T.CDFILIAL     = B.CDFILIAL          AND
                             T.CDFILIAL     = P.CDFILIAL          AND
                             T.NRTAREFA     = B.NRTAREFA          AND
                             P.NRPLATIVTARE = B.NRPLATIVTARE      AND
                             T.NRTAREFA     = P.NRTAREFA          AND
                             (T.CDCLIENTE   = CUR_CLIE.CDCLIENTE) AND  
                             P.NRAPURFATFAS IS NULL               AND
                             (TRUNC(T.DTCONCTAREFA) BETWEEN V_DATAINI AND V_DATAFIN) 
                          GROUP BY
                             T.CDFILIAL,
                             T.NRTAREFA
                          ORDER BY
                             T.CDFILIAL,
                             T.NRTAREFA) LOOP

            V_QTHRAPR := TRUNC(CUR_DESK.VRTEMPOAPROP / 0.25);
         
            IF V_QTHRAPR <> (CUR_DESK.VRTEMPOAPROP / 0.25) THEN
               V_QTHRAPR := V_QTHRAPR + 1;
            END IF;
         
            V_QTHRAPR := V_QTHRAPR * 0.25;
            V_QTHRTOT := V_QTHRTOT + V_QTHRAPR;
            V_VRFATU := V_VRFATU + (V_QTHRAPR * V_VALORSERV);     

            UPDATE
               PLANATIVTARE
            SET
               NRAPURFATFAS = SUBSTR(V_PRXAPURACAO, 11, 10)
            WHERE
               NRTAREFA = CUR_DESK.NRTAREFA         AND
               CDFILIAL = CUR_DESK.CDFILIAL         AND
               NRAPURFATFAS IS NULL;             
   
         END LOOP;
                  
         UPDATE 
            APURFATUFAS
         SET
            VRTOTAFATFAS = V_VRFATU
         WHERE
            NRAPURFATFAS = SUBSTR(V_PRXAPURACAO, 11, 10);
         
      END LOOP;

      V_DATAINI := ADD_MONTHS(V_DATAINI, 1);
      V_DATAFIN := ADD_MONTHS(V_DATAINI, 1);
      V_DATAFIN := V_DATAFIN - 1;   
   END LOOP;   
   COMMIT;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('FATURA_SERV_SUPORTE','5.01.003'); END;
/
